/* 
Public Teleport
Jamez_PrO
1.01
*/

/*
This is my first plugin.

*COMMANDS*
- say /save - Saves Your Location -
- say /teleport - Returns You To Location Saved -
- save(console) - Saves Your Location -
- teleport(console) - Saves You Location -
- say /infoteleport - Gives Commands -
- CVAR sv_publicteleport - Turns Off Public Teleport = Default 1 -
- CVAR sv_teleportreset - Turns Teleport Reset On Round Start = Default 0 -

*CREDITS*
- EKS -
- XxAvalanchexX -

- I would say what they helped me on but theres so much. thx guys - 
*/

#include <amxmodx>
#include <fun>

#define MAXPLAYERS 32

new username[32]
new g_userorigin[MAXPLAYERS+1][3]
new smokesprite

public plugin_init() 
{
	register_plugin("Public Teleport","1.01","Jamez_PrO")
	register_clcmd("say /teleport","public_teleport",0,"- teleports you to saven location") 
	register_clcmd("say /save","public_origin",0,"- saves your location")
	register_clcmd("say /infoteleport","info_teleport",0,"- gives teleport commands")
	register_concmd("save","public_origin",0,"- saves your location")
	register_concmd("teleport","public_teleport",0,"- teleports you to saven location")
	register_cvar("sv_publicteleport","1")
	register_cvar("sv_teleportreset","0")
	register_logevent("new_round",2,"0=World triggered", "1=Round_Start")
	register_clcmd("say","handlesay")
	return PLUGIN_CONTINUE
}

public plugin_precache( )
{
	precache_sound( "warcraft3/LightningBolt.wav" )
	smokesprite = precache_model( "sprites/smokepuff.spr" )
	return PLUGIN_CONTINUE
}

public public_origin(id)
{
	public_off(id)
	new cvar = get_cvar_num("sv_publicteleport") 
	if (cvar == 1 && is_user_alive(id))
	{ 
		get_user_origin(id,g_userorigin[id])
		client_print(id,print_chat,"[AMXX] Location Was Saved")
	} 
	return PLUGIN_HANDLED	
} 

public public_teleport(id)
{
	public_off(id)
	new cvar = get_cvar_num("sv_publicteleport")
	if (cvar == 1 && is_user_alive(id))
	{
		set_user_origin(id,g_userorigin[id])
		emit_sound( 0, CHAN_WEAPON, "warcraft3/LightningBolt.wav", 1.0, ATTN_NORM, 0, PITCH_NORM )
		say_teleport(id)			
	}
	return PLUGIN_HANDLED
}

public public_off(id)
{
	new cvar = get_cvar_num("sv_publicteleport")
	if (cvar == 0)
	{
		client_print(id,print_chat,"[AMXX] Public Teleport Is Currently Off")
	}
	return PLUGIN_HANDLED
}

say_teleport(id)
{
	get_user_name(id,username,31)
	client_print(0,print_chat,"[AMXX] %s Used Public Teleport",username)	
	smoke_effect(id)
}

public smoke_effect(id)
{
	new origin[3]
	get_user_origin( id, origin, 0 )
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( 17 )
	write_coord( origin[0] )
	write_coord( origin[1] )
	write_coord( origin[2] )
	write_short( smokesprite )
	write_byte( 10 )
	write_byte( 150 )
	message_end( )
}

public new_round(id)
{
	new cvar = get_cvar_num("sv_teleportreset")
	if (cvar == 1 && is_user_alive(id))
	client_cmd(id,"say /save")
	server_cmd("mp_freezetime 0")
	return PLUGIN_HANDLED
}

  
public handlesay(id)   
{  
	new thetext[512]  
	read_args(thetext,511)
	if(containi(thetext,"teleport") != -1)
	client_print(id,print_chat,"[AMXX] For Public Teleport Help Say /infoteleport")  
	return PLUGIN_CONTINUE  
}


public info_teleport(id)
{
	show_motd(id,"PublicTeleport: Say /save or type save in console to save your location. Say /teleport or type teleport in console to return to your saven location. If cvar sv_teleportreset = 1 your teleport will reset on round start...       This Plugin Was Made By Jamez_PrO... Any Questions E-mail Me Jamez_PrO@hotmail.com","Public Teleport") 
	return PLUGIN_HANDLED
}